/*
 * Copyright IBM Corp. and others 1991
 *
 * This program and the accompanying materials are made available under
 * the terms of the Eclipse Public License 2.0 which accompanies this
 * distribution and is available at https://www.eclipse.org/legal/epl-2.0/
 * or the Apache License, Version 2.0 which accompanies this distribution
 * and is available at https://www.apache.org/licenses/LICENSE-2.0.
 *
 * This Source Code may also be made available under the following
 * Secondary Licenses when the conditions for such availability set
 * forth in the Eclipse Public License, v. 2.0 are satisfied: GNU
 * General Public License, version 2 with the GNU Classpath
 * Exception [1] and GNU General Public License, version 2 with the
 * OpenJDK Assembly Exception [2].
 *
 * [1] https://www.gnu.org/software/classpath/license.html
 * [2] https://openjdk.org/legal/assembly-exception.html
 *
 * SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0-only WITH Classpath-exception-2.0 OR GPL-2.0-only WITH OpenJDK-assembly-exception-1.0
 */

/**
 * WARNING!!! GENERATED FILE
 *
 * This class is generated.
 * Do not use the Eclipse "Organize Imports" feature on this class.
 *
 * It can contain user content, but that content must be delimited with the
 * the tags
 * [BEGIN USER IMPORTS]
 * [END USER IMPORTS]
 *
 * or
 *
 * [BEGIN USER CODE]
 * [END USER CODE]
 *
 * These tags are entered as comments.  Characters before [ and after ] are ignored.
 * Lines between the tags are inserted into the newly generated file.
 *
 * IMPORTS are combined and inserted above newly generated imports.  CODE is combined
 * and inserted immediately after the class declaration
 *
 * All lines outside these tags are lost and replaced with newly generated code.
 */
package com.ibm.j9ddr.vm29.pointer.generated;

/*[BEGIN USER IMPORTS]*/
/*[END USER IMPORTS]*/

import com.ibm.j9ddr.CorruptDataException;
import com.ibm.j9ddr.vm29.pointer.*;
import com.ibm.j9ddr.vm29.structure.*;
import com.ibm.j9ddr.vm29.types.*;

/**
 * Structure: _PEB_LDR_DATAPointer
 *
 * A generated implementation of a VM structure
 *
 * This class contains generated code and MAY contain hand written user code.
 *
 * Hand written user code must be contained at the top of
 * the class file, specifically above
 * the comment line containing WARNING!!! GENERATED CODE
 *
 * ALL code below the GENERATED warning will be replaced with new generated code
 * each time the PointerGenerator utility is run.
 *
 * The generated code will provide getters for all elements in the _PEB_LDR_DATAPointer
 * structure.  Where possible, meaningful return types are inferred.
 *
 * The user may add methods to provide meaningful return types where only pointers
 * could be automatically inferred.
 */
@com.ibm.j9ddr.GeneratedPointerClass(structureClass=_PEB_LDR_DATA.class)
public class _PEB_LDR_DATAPointer extends StructurePointer {

	// NULL
	public static final _PEB_LDR_DATAPointer NULL = new _PEB_LDR_DATAPointer(0);

/*[BEGIN USER CODE]*/
/*[END USER CODE]*/

	// Do not call this constructor.  Use static method cast instead.
	protected _PEB_LDR_DATAPointer(long address) {
		super(address);
	}

	public static _PEB_LDR_DATAPointer cast(AbstractPointer structure) {
		return cast(structure.getAddress());
	}

	public static _PEB_LDR_DATAPointer cast(UDATA udata) {
		return cast(udata.longValue());
	}

	public static _PEB_LDR_DATAPointer cast(long address) {
		if (address == 0) {
			return NULL;
		}
		return new _PEB_LDR_DATAPointer(address);
	}

	public _PEB_LDR_DATAPointer add(long count) {
		return _PEB_LDR_DATAPointer.cast(address + (_PEB_LDR_DATA.SIZEOF * count));
	}

	public _PEB_LDR_DATAPointer add(Scalar count) {
		return add(count.longValue());
	}

	public _PEB_LDR_DATAPointer addOffset(long offset) {
		return _PEB_LDR_DATAPointer.cast(address + offset);
	}

	public _PEB_LDR_DATAPointer addOffset(Scalar offset) {
		return addOffset(offset.longValue());
	}

	public _PEB_LDR_DATAPointer sub(long count) {
		return _PEB_LDR_DATAPointer.cast(address - (_PEB_LDR_DATA.SIZEOF * count));
	}

	public _PEB_LDR_DATAPointer sub(Scalar count) {
		return sub(count.longValue());
	}

	public _PEB_LDR_DATAPointer subOffset(long offset) {
		return _PEB_LDR_DATAPointer.cast(address - offset);
	}

	public _PEB_LDR_DATAPointer subOffset(Scalar offset) {
		return subOffset(offset.longValue());
	}

	public _PEB_LDR_DATAPointer untag(long mask) {
		return _PEB_LDR_DATAPointer.cast(address & ~mask);
	}

	public _PEB_LDR_DATAPointer untag() {
		return untag(UDATA.SIZEOF - 1);
	}

	protected long sizeOfBaseType() {
		return _PEB_LDR_DATA.SIZEOF;
	}

	// Implementation methods

	// _LIST_ENTRY InMemoryOrderModuleList
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_InMemoryOrderModuleListOffset_", declaredType="_LIST_ENTRY")
	public _LIST_ENTRYPointer InMemoryOrderModuleList() throws CorruptDataException {
		return _LIST_ENTRYPointer.cast(nonNullFieldEA(_PEB_LDR_DATA._InMemoryOrderModuleListOffset_));
	}

	// _LIST_ENTRY InMemoryOrderModuleList
	public PointerPointer InMemoryOrderModuleListEA() throws CorruptDataException {
		return PointerPointer.cast(nonNullFieldEA(_PEB_LDR_DATA._InMemoryOrderModuleListOffset_));
	}

	// U8[] Reserved1
	public U8Pointer Reserved1EA() throws CorruptDataException {
		return U8Pointer.cast(nonNullFieldEA(_PEB_LDR_DATA._Reserved1Offset_));
	}

	// void*[] Reserved2
	public PointerPointer Reserved2EA() throws CorruptDataException {
		return PointerPointer.cast(nonNullFieldEA(_PEB_LDR_DATA._Reserved2Offset_));
	}

}
